#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct node {
	char palavra[20];
	int ocorrencias;
	struct node *next;
} Node;

int main(int argc, char *argv[]) {
	FILE *ficheiro;	
	char *nomeficheiro;
	char lido[20];
	Node *lista_ptr=NULL;
	Node *aux_ptr;

	if (argc != 2) {
		printf("Utilizacao: a.out <nomedoficheiro>\n");
		exit(1);
	}

	nomeficheiro = argv[1];
	ficheiro=fopen(nomeficheiro,"r");
			
	if (ficheiro==NULL) {
		printf("Erro na abertura do ficheiro!\n");
		exit(1);
	}

	while(fscanf(ficheiro," %s ",lido)==1) {
		aux_ptr = lista_ptr;
		while((aux_ptr!=NULL)&&(strcmp(lido,(*aux_ptr).palavra)!=0)) {
			aux_ptr=(*aux_ptr).next;
		}		
		if (aux_ptr==NULL) {
			aux_ptr=(Node *)malloc(sizeof(Node));
			strcpy((*aux_ptr).palavra,lido);
			(*aux_ptr).ocorrencias=1;
			(*aux_ptr).next=lista_ptr;
			lista_ptr=aux_ptr;
		} else {
			(*aux_ptr).ocorrencias++;
		}
	}

	for(aux_ptr=lista_ptr;aux_ptr!=NULL;aux_ptr=(*aux_ptr).next) {
		printf("%s -> %d\n",(*aux_ptr).palavra,(*aux_ptr).ocorrencias);		
	}

	exit(0);
}
