#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct no{
	char palavra[20];
	int ocorrencias;
	struct no *next;
} No;

int main(int argc, char *argv[]) {

	FILE *ficheiro;
	char *nomefic;
	char lido[20];
	No *lista_ptr=NULL;
	No *aux;

	if (argc != 2) {
		printf("Utilizacao correcta: wc <nomeficheiro>\n");
		exit(1);
	}

	nomefic=argv[1];

        ficheiro=fopen(nomefic,"r");

	if (ficheiro == NULL) {
		printf("Erro na abertura do ficheiro.\n");
		exit(1);
	}
	
	while (fscanf(ficheiro," %s ",lido)==1) {
		aux=lista_ptr;
		while ((aux!=NULL)&&(strcmp(lido,(*aux).palavra)!=0)) {
			aux=(*aux).next;
		}	
		
		if (aux != NULL) {
			(*aux).ocorrencias++;
		} else {
			aux=(No *)malloc(sizeof(No));
			strcpy((*aux).palavra,lido);
			(*aux).ocorrencias=1;
			(*aux).next=lista_ptr;
			lista_ptr=aux;
		}
	}

	for (aux=lista_ptr;aux!=NULL;aux=(*aux).next) {
		printf("%s -> %d\n",(*aux).palavra, (*aux).ocorrencias);
	}

	fclose(ficheiro);		

	exit(0);
}
